aboutsummaryrefslogtreecommitdiffstats
path: root/boot
diff options
context:
space:
mode:
authorMarco Platania <platania@research.att.com>2017-09-29 14:47:33 -0400
committerMarco Platania <platania@research.att.com>2017-09-29 14:47:33 -0400
commitba2ea344e2a3335739cee2eb1dcb6f1454f58a3a (patch)
treec3be8b7a3576cfabce20ef7f0b0b5cbe4e92a8e9 /boot
parent5eb3ff09d43f70269c52a293f0a9a09378b070b2 (diff)
Add DCAE GEN2 to Heat template
- Add DCAE GEN2 VM to all Heat templates - Add DCAE-related parameters - Create new install/init scripts for DCAE Change-Id: I299ad3b2c212a05d12a109fda21ce48980ddd448 Issue-ID: INT-213 Signed-off-by: Marco Platania <platania@research.att.com>
Diffstat (limited to 'boot')
-rw-r--r--boot/dcae2_install.sh147
-rw-r--r--boot/dcae2_serv.sh116
-rw-r--r--boot/dcae2_vm_init.sh11
3 files changed, 274 insertions, 0 deletions
diff --git a/boot/dcae2_install.sh b/boot/dcae2_install.sh
new file mode 100644
index 00000000..df1d513c
--- /dev/null
+++ b/boot/dcae2_install.sh
@@ -0,0 +1,147 @@
+#!/bin/bash
+
+# Read configuration files
+NEXUS_REPO=$(cat /opt/config/nexus_repo.txt)
+ARTIFACTS_VERSION=$(cat /opt/config/artifacts_version.txt)
+DNS_IP_ADDR=$(cat /opt/config/dns_ip_addr.txt)
+CLOUD_ENV=$(cat /opt/config/cloud_env.txt)
+EXTERNAL_DNS=$(cat /opt/config/external_dns.txt)
+MAC_ADDR=$(cat /opt/config/mac_addr.txt)
+
+MTU=$(/sbin/ifconfig | grep MTU | sed 's/.*MTU://' | sed 's/ .*//' | sort -n | head -1)
+
+if [[ $CLOUD_ENV != "rackspace" ]]
+then
+ # Add host name to /etc/host to avoid warnings in openstack images
+ echo 127.0.0.1 $(hostname) >> /etc/hosts
+
+ # Allow remote login as root
+ mv /root/.ssh/authorized_keys /root/.ssh/authorized_keys.bk
+ cp /home/ubuntu/.ssh/authorized_keys /root/.ssh
+fi
+
+# Set private IP in /etc/network/interfaces manually in the presence of public interface
+# Some VM images don't add the private interface automatically, we have to do it during the component installation
+if [[ $CLOUD_ENV == "openstack_nofloat" ]]
+then
+ CIDR=$(cat /opt/config/oam_network_cidr.txt)
+ BITMASK=$(echo $CIDR | cut -d"/" -f2)
+
+ # Compute the netmask based on the network cidr
+ if [[ $BITMASK == "8" ]]
+ then
+ NETMASK=255.0.0.0
+ elif [[ $BITMASK == "16" ]]
+ then
+ NETMASK=255.255.0.0
+ elif [[ $BITMASK == "24" ]]
+ then
+ NETMASK=255.255.255.0
+ fi
+
+ echo "auto eth1" >> /etc/network/interfaces
+ echo "iface eth1 inet static" >> /etc/network/interfaces
+ echo " address $DCAE_IP_ADDR" >> /etc/network/interfaces
+ echo " netmask $NETMASK" >> /etc/network/interfaces
+ echo " mtu $MTU" >> /etc/network/interfaces
+ ifup eth1
+fi
+
+# Download dependencies
+echo "deb http://ppa.launchpad.net/openjdk-r/ppa/ubuntu $(lsb_release -c -s) main" >> /etc/apt/sources.list.d/java.list
+echo "deb-src http://ppa.launchpad.net/openjdk-r/ppa/ubuntu $(lsb_release -c -s) main" >> /etc/apt/sources.list.d/java.list
+apt-get update
+apt-get install --allow-unauthenticated -y apt-transport-https ca-certificates wget make openjdk-8-jdk git ntp ntpdate
+
+# Download scripts from Nexus
+curl -k $NEXUS_REPO/org.onap.demo/boot/$ARTIFACTS_VERSION/dcae2_vm_init.sh -o /opt/dcae2_vm_init.sh
+curl -k $NEXUS_REPO/org.onap.demo/boot/$ARTIFACTS_VERSION/dcae2_serv.sh -o /opt/dcae2_serv.sh
+chmod +x /opt/dcae2_vm_init.sh
+chmod +x /opt/dcae2_serv.sh
+mv /opt/dcae2_serv.sh /etc/init.d
+update-rc.d dcae_serv.sh defaults
+
+# Download and install docker-engine and docker-compose
+echo "deb https://apt.dockerproject.org/repo ubuntu-xenial main" | sudo tee /etc/apt/sources.list.d/docker.list
+apt-get update
+apt-get install -y linux-image-extra-$(uname -r) linux-image-extra-virtual
+apt-get install -y --allow-unauthenticated docker-engine
+
+mkdir /opt/docker
+curl -L https://github.com/docker/compose/releases/download/1.9.0/docker-compose-`uname -s`-`uname -m` > /opt/docker/docker-compose
+chmod +x /opt/docker/docker-compose
+
+# Set the MTU size of docker containers to the minimum MTU size supported by vNICs. OpenStack deployments may need to know the external DNS IP
+DNS_FLAG=""
+if [ -s /opt/config/dns_ip_addr.txt ]
+then
+ DNS_FLAG=$DNS_FLAG"--dns $(cat /opt/config/dns_ip_addr.txt) "
+fi
+if [ -s /opt/config/external_dns.txt ]
+then
+ DNS_FLAG=$DNS_FLAG"--dns $(cat /opt/config/external_dns.txt) "
+fi
+echo "DOCKER_OPTS=\"$DNS_FLAG--mtu=$MTU\"" >> /etc/default/docker
+
+cp /lib/systemd/system/docker.service /etc/systemd/system
+sed -i "/ExecStart/s/$/ --mtu=$MTU/g" /etc/systemd/system/docker.service
+service docker restart
+
+# DNS IP address configuration
+echo "nameserver "$DNS_IP_ADDR >> /etc/resolvconf/resolv.conf.d/head
+resolvconf -u
+
+# Build a configuration file for the DCAE Controller.
+chmod 777 /opt/config/priv_key
+mkdir /opt/app
+
+UBUNTU_1604_IMAGE=$(cat /opt/config/ubuntu_1604_image.txt)
+CENTOS_7_IMAGE=$(cat /opt/config/centos_7_image.txt)
+FLAVOR_MEDIUM=$(cat /opt/config/flavor_medium.txt)
+SECURITY_GROUP=$(cat /opt/config/security_group.txt)
+PUBLIC_NET_ID=$(cat /opt/config/public_net_id.txt)
+OPENSTACK_PRIVATE_NETWORK=$(cat /opt/config/openstack_private_network_name.txt)
+OPENSTACK_USER=$(cat /opt/config/openstack_user.txt)
+OPENSTACK_PASSWORD=$(cat /opt/config/openstack_password.txt)
+OPENSTACK_TENANT_ID=$(cat /opt/config/tenant_id.txt)
+KEYSTONE_URL=$(cat /opt/config/keystone_url.txt)"/v2.0"
+OPENSTACK_REGION=$(cat /opt/config/openstack_region.txt)
+OPENSTACK_KEYNAME=$(cat /opt/config/key_name.txt)"_"$(cat /opt/config/rand_str.txt)
+ZONE=$(cat /opt/config/dcae_zone.txt)
+
+cat > /opt/app/inputs.yaml << EOF_CONFIG
+centos7image_id: '$CENTOS_7_IMAGE'
+ubuntu1604image_id: '$UBUNTU_1604_IMAGE'
+flavor_id: '$FLAVOR_MEDIUM'
+security_group: '$SECURITY_GROUP'
+public_net: '$PUBLIC_NET_ID'
+private_net: '$OPENSTACK_PRIVATE_NETWORK'
+openstack:
+ username: '$OPENSTACK_USER'
+ password: '$OPENSTACK_PASSWORD'
+ tenant_name: '$OPENSTACK_TENANT_ID'
+ auth_url: '$KEYSTONE_URL'
+ region: '$OPENSTACK_REGION'
+keypair: '$OPENSTACK_KEYNAME'
+key_filename: '/opt/dcae/key'
+location_prefix: '$ZONE'
+location_domain: 'onapdevlab.onap.org'
+codesource_url: 'https://nexus.onap.org/service/local/repositories/raw/content'
+codesource_version: 'org.onap.dcaegen2.deployments/releases/scripts'
+EOF_CONFIG
+
+# Rename network interface in openstack Ubuntu 16.04 images. Then, reboot the VM to pick up changes
+if [[ $CLOUD_ENV != "rackspace" ]]
+then
+ sed -i "s/GRUB_CMDLINE_LINUX=.*/GRUB_CMDLINE_LINUX=\"net.ifnames=0 biosdevname=0\"/g" /etc/default/grub
+ grub-mkconfig -o /boot/grub/grub.cfg
+ sed -i "s/ens[0-9]*/eth0/g" /etc/network/interfaces.d/*.cfg
+ sed -i "s/ens[0-9]*/eth0/g" /etc/udev/rules.d/70-persistent-net.rules
+ echo 'network: {config: disabled}' >> /etc/cloud/cloud.cfg.d/99-disable-network-config.cfg
+ echo "APT::Periodic::Unattended-Upgrade \"0\";" >> /etc/apt/apt.conf.d/10periodic
+ reboot
+fi
+
+# Run docker containers
+cd /opt
+./dcae2_vm_init.sh
diff --git a/boot/dcae2_serv.sh b/boot/dcae2_serv.sh
new file mode 100644
index 00000000..bfd2ad18
--- /dev/null
+++ b/boot/dcae2_serv.sh
@@ -0,0 +1,116 @@
+
+#############################################################################
+#
+# Copyright © 2017 AT&T Intellectual Property. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+#############################################################################
+
+#!/bin/sh
+### BEGIN INIT INFO
+# Provides:
+# Required-Start: $remote_fs $syslog
+# Required-Stop: $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: Start daemon at boot time
+# Description: Enable service provided by daemon.
+### END INIT INFO
+
+dir="/opt"
+cmd="./dcae2_vm_init.sh"
+user="root"
+
+name=`basename $0`
+pid_file="/var/run/$name.pid"
+stdout_log="/var/log/$name.log"
+stderr_log="/var/log/$name.err"
+
+get_pid() {
+ cat "$pid_file"
+}
+
+is_running() {
+ [ -f "$pid_file" ] && ps `get_pid` > /dev/null 2>&1
+}
+
+case "$1" in
+ start)
+ if is_running; then
+ echo "Already started"
+ else
+ echo "Starting $name"
+ cd "$dir"
+ if [ -z "$user" ]; then
+ sudo $cmd >> "$stdout_log" 2>> "$stderr_log" &
+ else
+ sudo -u "$user" $cmd >> "$stdout_log" 2>> "$stderr_log" &
+ fi
+ echo $! > "$pid_file"
+ if ! is_running; then
+ echo "Unable to start, see $stdout_log and $stderr_log"
+ exit 1
+ fi
+ fi
+ ;;
+ stop)
+ if is_running; then
+ echo -n "Stopping $name.."
+ kill `get_pid`
+ for i in {1..10}
+ do
+ if ! is_running; then
+ break
+ fi
+
+ echo -n "."
+ sleep 1
+ done
+ echo
+
+ if is_running; then
+ echo "Not stopped; may still be shutting down or shutdown may have failed"
+ exit 1
+ else
+ echo "Stopped"
+ if [ -f "$pid_file" ]; then
+ rm "$pid_file"
+ fi
+ fi
+ else
+ echo "Not running"
+ fi
+ ;;
+ restart)
+ $0 stop
+ if is_running; then
+ echo "Unable to stop, will not attempt to start"
+ exit 1
+ fi
+ $0 start
+ ;;
+ status)
+ if is_running; then
+ echo "Running"
+ else
+ echo "Stopped"
+ exit 1
+ fi
+ ;;
+ *)
+ echo "Usage: $0 {start|stop|restart|status}"
+ exit 1
+ ;;
+esac
+
+exit 0
diff --git a/boot/dcae2_vm_init.sh b/boot/dcae2_vm_init.sh
new file mode 100644
index 00000000..b9da6844
--- /dev/null
+++ b/boot/dcae2_vm_init.sh
@@ -0,0 +1,11 @@
+#!/bin/bash
+
+NEXUS_USER=$(cat /opt/config/nexus_username.txt)
+NEXUS_PASSWORD=$(cat /opt/config/nexus_password.txt)
+NEXUS_DOCKER_REPO=$(cat /opt/config/nexus_docker_repo.txt)
+DOCKER_VERSION=$(cat /opt/config/docker_version.txt)
+ZONE=$(cat /opt/config/dcae_zone.txt)
+
+docker login -u $NEXUS_USER -p $NEXUS_PASSWORD $NEXUS_DOCKER_REPO
+docker pull $NEXUS_DOCKER_REPO/onap/org.onap.dcaegen2.deployments.bootstrap:$DOCKER_VERSION
+docker run -v /opt/config/priv_key:/opt/app/installer/config/key -v /opt/app/inputs.yaml:/opt/app/installer/config/inputs.yaml -e "LOCATION=$ZONE" $NEXUS_DOCKER_REPO/onap/org.onap.dcaegen2.deployments.bootstrap:$DOCKER_VERSION \ No newline at end of file